
package dataspork.gui;

import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import dataspork.view.*;
import dataspork.util.*;
import dataspork.plot.*;
import dataspork.gui.CommonFrame;
import dataspork.gui.InterpreterGUI;
import dataspork.stat.grData;
import dataspork.interp.grFromConfig;
import dataspork.view.PairDistributionGraph;


public class grGUI extends CommonFrame
     implements InterpreterGUI, ActionListener, DataListener {

   protected PairDistributionGraph grGraph;
   protected PlotPanel grGraphPanel;
   protected grTextPanel controlPanel;
   protected JPanel cPanel;
   protected grData grd;
   protected grFromConfig gfc;

   public grGUI(grFromConfig gfc){
     this.gfc = gfc;

     setTitle(gfc.getName());

     JMenuUtil.addMenu(menuBar,"File",
                       new String[] {"Export to File","Close"}, 
                       new String[] {"exportfile","close"}, 
                       new int[] {KeyEvent.VK_S,KeyEvent.VK_W},
                       this);



     grd = gfc.getgrData();

     grGraph =  new PairDistributionGraph(grd);

     grGraphPanel = new PlotPanel(grGraph.getPlot());
     grGraphPanel.setPreferredSize(new Dimension(400,250));
     grGraphPanel.setBackground(Color.white);
//     grGraphPanel.setBorder(new EmptyBorder(5,70,20,5));
     grGraphPanel.setBorder(
           BorderFactory.createTitledBorder(
             BorderFactory.createMatteBorder(10,50,30,10,Color.white),
             "Pair Correlation Function g(r)",
             TitledBorder.CENTER,TitledBorder.BELOW_TOP));
          

     contentPane.setLayout(new BoxLayout(contentPane,BoxLayout.X_AXIS));
     contentPane.add(grGraphPanel);

     
     controlPanel = new grTextPanel(grd);     
     controlPanel.setBorder(CommonFrame.BORDER);


     cPanel = new JPanel();
     cPanel.setLayout(new BoxLayout(cPanel,BoxLayout.Y_AXIS));
     cPanel.add(controlPanel);
     cPanel.setBorder(new EmptyBorder(10,10,10,10));
     contentPane.add(cPanel);


     grd.addListener(this);

     pack();
     show();     
     
   }
   public void dataChanged(Object o){
      grGraphPanel.repaint();
   }

   public void actionPerformed(ActionEvent event){
      String command = event.getActionCommand();
      if (command.equals("close")) {
         Runnable hideFrame = new Runnable(){
            public void run() {setVisible(false); }
         };
      SwingUtilities.invokeLater(hideFrame);
      }
      if (command.equals("exportfile")){
    //    System.out.println("Exporting file\n");
        File file = new File(".");
        JFileChooser choosy = new JFileChooser(file);
        File defile = new File("gr.dat");
        choosy.setSelectedFile(defile);
        int state=choosy.showSaveDialog(this);
        if (state==choosy.APPROVE_OPTION) {
           File newfile = choosy.getSelectedFile();
     //      System.out.println("You choose:"+choosy.getName(newfile)+"\n");
           try {
             FileWriter fw = new FileWriter(choosy.getName(newfile));
             grd.write(fw);
             fw.close();
           } catch (IOException e) {
              System.out.println("Couldn't save to "+choosy.getName(newfile)
                                   +"\n");
           }
        }
      }
      
   }


}
