
package dataspork.gui;
import dataspork.util.skModel;
import dataspork.util.DataListener;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class skControl extends KeyAdapter
   implements ActionListener, FocusListener, DataListener {

   protected skModel skmodel;
   protected JTextField startField;
   protected JTextField kshellField;

   public skControl(skModel skm, JTextField startF, JTextField kshellF){

       skmodel = skm;
       startField = startF;
       kshellField = kshellF;
       setTextValues();
       startF.addActionListener(this);
       startF.addFocusListener(this);
       startF.addKeyListener(this);
       kshellF.addActionListener(this);
       kshellF.addFocusListener(this);
       kshellF.addKeyListener(this);

       skmodel.addListener(this);

   }
 
   protected void setTextValues(){
      startField.setText(Integer.toString(skmodel.getCutoff()));
      kshellField.setText(Integer.toString(skmodel.getKShell()));
   }   

   public void actionPerformed(ActionEvent event){
      if (event.getSource()==startField) {
         try{
          skmodel.setCutoff(Integer.valueOf(startField.getText()).intValue());
         } catch (NumberFormatException e){}
      }
      if (event.getSource()==kshellField) {
         try{
          skmodel.setKShell(Integer.valueOf(kshellField.getText()).intValue());
         } catch (NumberFormatException e){}
      }
      setTextValues();
   }

   public void focusLost(FocusEvent e){
      Object source = e.getSource();
      if (!e.isTemporary()) {
         actionPerformed(
           new ActionEvent(source,ActionEvent.ACTION_PERFORMED,null) ) ;
      }
   }

   public void focusGained(FocusEvent e){
   }

   public void keyTyped(KeyEvent k){
      int code = k.getKeyCode();
      if (code==k.VK_ENTER){ 
         actionPerformed(new
            ActionEvent(k.getSource(),ActionEvent.ACTION_PERFORMED,null) );
      }
   }

   public void dataChanged(Object o){
      setTextValues();
   }


}
