package dataspork.reader;
import dataspork.tree.*;
import dataspork.reader.*;
import dataspork.interp.*;
import java.io.*;
import java.net.URL;

// MultiConfigReader reads configuration files (configurations as a 
// function of computer time), links interpreters which directly
// calculate g(r) and S(k)

public class MultiConfigReader implements DataReader {

  public MultiConfigReader() {}

  public DataTreeNode read(URL url) {

    String filename = url.getFile();
    int k = filename.lastIndexOf('/');
    String shortFilename = filename.substring(++k);
    DataTreeNode node = null;

    try {

      DataSource data = new MultipleConfigSource(url);
      node = new DataTreeNode(shortFilename,data);
      node.addInterpreter(new InterpreterClass(grFromConfig.class,node));
      node.addInterpreter(new InterpreterClass(skFromConfig.class,node));

    } catch (Exception exc) {
      System.out.println("exception in MultiConfigReader: " + exc);
    }

    return node;


  }
}
