package pupi.reader;
import dataspork.tree.*;
import dataspork.reader.*;
import dataspork.util.*;
import java.io.*;

/** Read tensors from ascii files, using format from David Ceperley's codes.
  * This class doesn't actually implement dataspork.core.DataReader, but that
  * should be changed soon.
  */
public class TensorReader {
  private SciStreamTokenizer t;

  public TensorReader(SciStreamTokenizer t) {
    this.t = t;
  }

  public DataSource getDataSource() throws IOException {
    double data[] = new double [0];
    int dims[]=null;
    while (t.ttype!=t.TT_EOF) {
      t.nextToken();
      if (t.ttype==t.TT_WORD) {
        //System.out.println(t.sval);
        if (t.sval.equals("RANK")) {
          t.nextToken();
          dims = new int[(int)t.nval];
          for (int i=0; i<dims.length; i++) {
            t.nextToken();
            dims[i] = (int)t.nval;
          }
        }

        else if (t.sval.equals("BEGIN")) {
          while(t.ttype!=t.TT_EOL && t.ttype!=t.TT_EOF) t.nextToken();
          t.eolIsSignificant(false);
          int size=1;
          for (int i=0; i<dims.length; i++) size*=dims[i];
          data = new double[size];
          for (int i=0; i<data.length; i++) {
            t.nextToken();
            data[i]=t.nval;
          }
          t.eolIsSignificant(true);
          return new ConstDataSource(data,dims,DataSource.DOUBLE);
        }
      }
      while(t.ttype!=t.TT_EOL && t.ttype!=t.TT_EOF) t.nextToken();
    }
for (int i=0;i<dims.length;i++) System.out.println(dims[i]); 
System.out.println(data.length);
    return new ConstDataSource(data,dims,DataSource.DOUBLE);
  }
}
